<!DOCTYPE html>
<html>
<head>
  <meta charset=utf-8/>
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Firebase Cloud Messaging Example</title>

  <link rel="stylesheet" href="https://code.getmdl.io/1.1.3/material.orange-indigo.min.css">
  <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
  <script defer src="https://code.getmdl.io/1.1.3/material.min.js"></script>

  <link rel="stylesheet" href="main.css">

  <link rel="manifest" href="/manifest.json">
</head>
<body>
<div class="demo-layout mdl-layout mdl-js-layout mdl-layout--fixed-header">

  <header class="mdl-layout__header mdl-color-text--white mdl-color--light-blue-700">
    <div class="mdl-cell mdl-cell--12-col mdl-cell--12-col-tablet mdl-grid">
      <div class="mdl-layout__header-row mdl-cell mdl-cell--12-col mdl-cell--12-col-tablet mdl-cell--8-col-desktop">
        <h3>Firebase Cloud Messaging</h3>
      </div>
    </div>
  </header>

  <main class="mdl-layout__content mdl-color--grey-100">
    <div class="mdl-cell mdl-cell--12-col mdl-cell--12-col-tablet mdl-grid">

      <div class="mdl-card mdl-shadow--2dp mdl-cell mdl-cell--12-col mdl-cell--12-col-tablet mdl-cell--12-col-desktop">
        <div class="mdl-card__supporting-text mdl-color-text--grey-600">
          <div id="token_div" style="display: none;">
            <h4>Instance ID Token</h4>
            <p id="token" style="word-break: break-all;"></p>
            <button class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored"
                    onclick="deleteToken()">Delete Token</button>
          </div>
          <div id="permission_div" style="display: none;">
            <h4>Needs Permission</h4>
            <p id="token"></p>
            <button class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored"
                    onclick="requestPermission()">Request Permission</button>
          </div>
          <div id="messages"></div>
        </div>
      </div>

    </div>
  </main>
</div>
<script src="https://www.gstatic.com/firebasejs/4.1.2/firebase.js"></script>
<script>
  var config = {
    apiKey: "AIzaSyA00Qu_RcW6uDUvKsi08UMT7ikU40wolls",
    authDomain: "sport-heist.firebaseapp.com",
    projectId: "sport-heist",
    storageBucket: "sport-heist.appspot.com",
    messagingSenderId: "603016688312",
    appId: "1:603016688312:web:181c81e38ea8790a2d7a4d",
    measurementId: "G-XXM5MWZ23B"
  };
  firebase.initializeApp(config);
</script>
<script>
  const messaging = firebase.messaging();

  const tokenDivId = 'token_div';
  const permissionDivId = 'permission_div';

  messaging.onTokenRefresh(function() {
    messaging.getToken()
    .then(function(refreshedToken) {
      console.log('Token refreshed.');
      setTokenSentToServer(false);
      sendTokenToServer(refreshedToken);
      resetUI();
    })
    .catch(function(err) {
      console.log('Unable to retrieve refreshed token ', err);
      showToken('Unable to retrieve refreshed token ', err);
    });
  });

  messaging.onMessage(function(payload) {
    console.log("Message received. ", payload);
    console.log('>>>>> ',JSON.parse(payload.data.payload));
    appendMessage(payload);
  });

  function resetUI() {
    clearMessages();
    showToken('loading...');

    console.log("getting token")
    messaging.getToken().then((resp) => {
      console.log(resp)
    })
    messaging.getToken()
    .then(function(currentToken) {
      console.log("Got current token")
      if (currentToken) {
        sendTokenToServer(currentToken);
        updateUIForPushEnabled(currentToken);
      } else {
        console.log('No Instance ID token available. Request permission to generate one.');
        updateUIForPushPermissionRequired();
        setTokenSentToServer(false);
      }
    })
    .catch(function(err) {
      console.log('An error occurred while retrieving token. ', err);
      showToken('Error retrieving Instance ID token. ', err);
      setTokenSentToServer(false);
    });
    console.log("End get token")

  }

  function showToken(currentToken) {
    var tokenElement = document.querySelector('#token');
    console.log(tokenElement)
    console.log(currentToken)
    tokenElement.textContent = currentToken;
  }

  function sendTokenToServer(currentToken) {
    if (!isTokenSentToServer()) {
      var accessToken = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ0b2tlbl90eXBlIjoiYWNjZXNzIiwiZXhwIjoxNzA1NDAzNDI4LCJpYXQiOjE3MDUzOTk4MjgsImp0aSI6ImYxOWFlZWYyNzc5YjQ0ZGM4YzAyMWVmZDE3MjhhYWY5IiwidXNlcl9pZCI6Mn0.vpSxtHCMIhy7udaimxBsWqCxLa14OAGxiWU3FJiydns'
      console.log('Sending token to server...');
      fetch('http://localhost:8000/api/firebase/devices/', {
        method: "POST",
        headers: {
            'Content-Type': 'application/json',
            'Authorization': 'Bearer ' + accessToken
          },
        body: JSON.stringify({
          'registration_id': currentToken,
          'type': 'web',
          'device_id': 'fds'
        }),
        credentials: "include",
      }).then(function(response) {
        console.log('accessToken   ', accessToken);
        console.log(response);
      })
      setTokenSentToServer(true);
    } else {
      console.log('Token already sent to server so won\'t send it again ' +
          'unless it changes');
    }

  }

  function isTokenSentToServer() {
    if (window.localStorage.getItem('sentToServer') == 1) {
      return true;
    }
    return false;
  }

  function setTokenSentToServer(sent) {
    if (sent) {
      window.localStorage.setItem('sentToServer', 1);
    } else {
      window.localStorage.setItem('sentToServer', 0);
    }
  }

  function showHideDiv(divId, show) {
    const div = document.querySelector('#' + divId);
    if (show) {
      div.style = "display: visible";
    } else {
      div.style = "display: none";
    }
  }

  function requestPermission() {
    console.log('Requesting permission...');
    messaging.requestPermission()
    .then(function() {
      console.log('Notification permission granted.');
      resetUI();
    })
    .catch(function(err) {
      console.log('Unable to get permission to notify.', err);
    });
  }

  function deleteToken() {
    messaging.getToken()
    .then(function(currentToken) {
      messaging.deleteToken(currentToken)
      .then(function() {
        console.log('Token deleted.');
        setTokenSentToServer(false);
        resetUI();
      })
      .catch(function(err) {
        console.log('Unable to delete token. ', err);
      });
    })
    .catch(function(err) {
      console.log('Error retrieving Instance ID token. ', err);
      showToken('Error retrieving Instance ID token. ', err);
    });

  }

  function appendMessage(payload) {
    const messagesElement = document.querySelector('#messages');
    const dataHeaderELement = document.createElement('h5');
    const dataElement = document.createElement('pre');
    dataElement.style = 'overflow-x:hidden;'
    dataHeaderELement.textContent = 'Received message:';
    dataElement.textContent = JSON.stringify(payload, null, 2);
    messagesElement.appendChild(dataHeaderELement);
    messagesElement.appendChild(dataElement);
  }

  function clearMessages() {
    const messagesElement = document.querySelector('#messages');
    while (messagesElement.hasChildNodes()) {
      console.log("Has children")
      messagesElement.removeChild(messagesElement.lastChild);
    }
  }

  function updateUIForPushEnabled(currentToken) {
    showHideDiv(tokenDivId, true);
    showHideDiv(permissionDivId, false);
    showToken(currentToken);
  }

  function updateUIForPushPermissionRequired() {
    showHideDiv(tokenDivId, false);
    showHideDiv(permissionDivId, true);
  }

  resetUI();
</script>
</body>
</html>
